package cn.talkcloud.talksdkdemo;

import android.Manifest;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.pm.PackageManager;
import android.media.AudioManager;
import android.os.Build;
import android.provider.Settings;
import android.support.annotation.NonNull;
import android.support.v4.app.ActivityCompat;
import android.support.v4.content.ContextCompat;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.text.TextUtils;
import android.view.KeyEvent;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.EditText;
import android.widget.Toast;


import com.talkcloud.media.entity.TK_VIDEO_CODEC;
import com.talkcloud.room.TKRoomManager;
import com.talkcloud.room.entity.TK_VIDEO_STREAM_TYPE;

import org.tkwebrtc.voiceengine.WebRtcAudioUtils;

import java.util.HashMap;

import cn.talkcloud.talksdkdemo.utils.ToastUtils;

import static android.os.Build.VERSION.SDK_INT;

/**
 * A login screen that offers login via email/password.
 */
public class LoginActivity extends AppCompatActivity{


    private EditText mAccountlView;
    private EditText meditText;
    private EditText mPasswordView;
    private EditText mNickNameView;
    private EditText mHostView;
    private CheckBox logcat;
    private CheckBox autoav;
    private CheckBox audioonly;
    private CheckBox enabledual;

    private boolean islogcat = false;
    private boolean isautoav = false;
    private boolean isaudio = false;
    private boolean isenabledual = false;

    private SharedPreferences sp  = null;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_login);
        mAccountlView = (EditText) findViewById(R.id.account);
        meditText = (EditText) findViewById(R.id.et_login_type);
        mPasswordView = (EditText) findViewById(R.id.password);
        mNickNameView = (EditText) findViewById(R.id.nickname);
        mHostView = (EditText) findViewById(R.id.host);

        logcat = (CheckBox) findViewById(R.id.logcat);
        autoav = (CheckBox) findViewById(R.id.autoav);
        audioonly = (CheckBox) findViewById(R.id.audio);
        enabledual = (CheckBox) findViewById(R.id.enable_dual);

        sp = getSharedPreferences("User", Context.MODE_PRIVATE);

        logcat.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                islogcat = isChecked ;
            }
        });

        autoav.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                isautoav = isChecked ;
            }
        });

        audioonly.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                isaudio = isChecked ;
            }
        });
        enabledual.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                isenabledual = isChecked ;
            }
        });


        Button mEmailSignInButton = (Button) findViewById(R.id.email_sign_in_button);
        mEmailSignInButton.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View view) {
                attemptLogin();
            }
        });

        if (mAccountlView.getText().toString()!=null)
            mAccountlView.setText(sp.getString("account",""));
        if (meditText.getText().toString()!=null)
            meditText.setText(sp.getString("type",""));
        if (mPasswordView.getText().toString()!=null)
            mPasswordView.setText(sp.getString("password",""));
        if (mHostView.getText().toString()!=null)
            mHostView.setText(sp.getString("host",""));
        if (mNickNameView.getText().toString()!=null)
            mNickNameView.setText(sp.getString("nickname",""));


    }
    public boolean checkSelfPermission(String permission, int requestCode) {
        if (ContextCompat.checkSelfPermission(this,
                permission)
                != PackageManager.PERMISSION_GRANTED) {

            ActivityCompat.requestPermissions(this,
                    new String[]{permission},
                    requestCode);
            return false;
        }
        return true;
    }
    private static final int PERMISSION_REQ_ID_RECORD_AUDIO = 22;
    private static final int PERMISSION_REQ_ID_CAMERA = PERMISSION_REQ_ID_RECORD_AUDIO + 1;
    @Override
    public void onRequestPermissionsResult(int requestCode,
                                           @NonNull String permissions[], @NonNull int[] grantResults) {
        switch (requestCode) {
            case PERMISSION_REQ_ID_RECORD_AUDIO: {
                if (grantResults.length > 0
                        && grantResults[0] == PackageManager.PERMISSION_GRANTED) {
                    checkSelfPermission(Manifest.permission.CAMERA, PERMISSION_REQ_ID_CAMERA);
                } else {
                    /*Tools.ShowAlertDialog(this, getString(R.string.mic_hint));*/
                    showLongToast("No permission for " + Manifest.permission.RECORD_AUDIO);
                }
                break;
            }
            case PERMISSION_REQ_ID_CAMERA: {
                if (grantResults.length > 0
                        && grantResults[0] == PackageManager.PERMISSION_GRANTED) {
                    init();
                } else {
                    showLongToast("No permission for " + Manifest.permission.CAMERA);
                    /*Tools.ShowAlertDialog(this, getString(R.string.camera_hint));*/
                }
                break;
            }
        }
    }

    private void init() {
        //初始化操作
        HashMap<String,Object> initParams = new HashMap<>();
//        initParams.put("AudioSource", AudioManager.STREAM_MUSIC);
        initParams.put(TKRoomManager.autoSubAV,true);
        initParams.put(TKRoomManager.useSecureSocket,true);
        initParams.put(TKRoomManager.tkPort,443);
        //initParams.put(TKRoomManager.tkVideocodec, TK_VIDEO_CODEC.H264);
//        initParams.put(TKRoomManager.tkAudioStereo,true);78y898
//        MediaCodecVideoEncoder.setNv21OrYv12(true);
        boolean issupported = WebRtcAudioUtils.isAcousticEchoCancelerSupported();
        TKRoomManager.init(getApplicationContext(), "Z5ePQ1UqRjebpskk",initParams);

    }

    public final void showLongToast(final String msg) {
        this.runOnUiThread(new Runnable() {
            @Override
            public void run() {
                Toast.makeText(getApplicationContext(), msg, Toast.LENGTH_LONG).show();
            }
        });
    }


    private void attemptLogin() {

        String account = mAccountlView.getText().toString();
        String type = meditText.getText().toString();
        String password = mPasswordView.getText().toString();
        String host = mHostView.getText().toString();
        String nickanme = mNickNameView.getText().toString();

        if (TextUtils.isEmpty(account)) {
            ToastUtils.showToast(this,"房间号不能为空！");
            return;
        }
        if (TextUtils.isEmpty(type)) {
            ToastUtils.showToast(this,"角色类型不能为空");
            return;
        }
        if (TextUtils.isEmpty(host)) {
            ToastUtils.showToast(this,"域名不能为空");
            return;
        }
        if (TextUtils.isEmpty(nickanme)) {
            ToastUtils.showToast(this,"昵称不能为空");
            return;
        }


//        if (isaudio)
//            TKRoomManager.getInstance().switchOnlyAudioRoom(!TKRoomManager.getInstance().isAudioOnlyRoom());
//        else
//            TKRoomManager.getInstance().switchOnlyAudioRoom(TKRoomManager.getInstance().isAudioOnlyRoom());

        Intent intent = new Intent(LoginActivity.this, VideoChatSampleActivity.class);
        intent.putExtra("account", account);
        intent.putExtra("type", type);
        intent.putExtra("password", password);
        intent.putExtra("isLogcat", islogcat);
        intent.putExtra("host",host);
        intent.putExtra("nickname",nickanme);
        TKRoomManager.getInstance().enableDualStream(isenabledual);
        startActivity(intent);


        //保存

        SharedPreferences.Editor editor = sp.edit();
        editor.putString("account", account);
        editor.putString("type", type);
        editor.putString("password", password);
        editor.putString("host",host);
        editor.putString("nickname",nickanme);
        editor.commit();

    }

    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        if(keyCode == KeyEvent.KEYCODE_BACK){
            TKRoomManager.getInstance().destroy();
        }
        return super.onKeyDown(keyCode, event);
    }

    @Override
    protected void onStart() {
        if (checkSelfPermission(Manifest.permission.RECORD_AUDIO, PERMISSION_REQ_ID_RECORD_AUDIO) && checkSelfPermission(Manifest.permission.CAMERA, PERMISSION_REQ_ID_CAMERA)) {
            init();
        }
//        if(Build.VERSION.SDK_INT>=23)
//        {
//            if(Settings.canDrawOverlays(this))
//            {
//                //有悬浮窗权限开启服务绑定 绑定权限
//                Intent intent = new Intent(LoginActivity.this, FBService.class);
//                startService(intent);
//
//            }else{
//                //没有悬浮窗权限m,去开启悬浮窗权限
//                try{
//                    Intent  intent=new Intent(Settings.ACTION_MANAGE_OVERLAY_PERMISSION);
//                    startActivityForResult(intent, OVERLAY_PERMISSION_REQ_CODE);
//                }catch (Exception e)
//                {
//                    e.printStackTrace();
//                }
//
//            }
//        } else{
//            //默认有悬浮窗权限  但是 华为, 小米,oppo等手机会有自己的一套Android6.0以下  会有自己的一套悬浮窗权限管理 也需要做适配
//            Intent intent = new Intent(LoginActivity.this, FBService.class);
//            startService(intent);
//        }
        super.onStart();
    }
}

