package cn.talkcloud.talksdkdemo;

import android.Manifest;
import android.annotation.SuppressLint;
import android.app.Activity;
import android.app.UiModeManager;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.content.res.Configuration;
import android.graphics.drawable.ColorDrawable;
import android.media.AudioManager;
import android.media.projection.MediaProjectionManager;
import android.os.Build;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.os.PersistableBundle;
import android.os.PowerManager;
import android.support.annotation.NonNull;
import android.support.annotation.RequiresApi;
import android.support.v4.app.ActivityCompat;
import android.support.v4.content.ContextCompat;
import android.support.v7.app.AlertDialog;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.text.TextUtils;
import android.util.DisplayMetrics;
import android.util.Log;
import android.view.Display;
import android.view.Gravity;
import android.view.KeyEvent;
import android.view.LayoutInflater;
import android.view.MotionEvent;
import android.view.View;
import android.view.ViewGroup;
import android.view.inputmethod.EditorInfo;
import android.widget.Button;
import android.widget.EditText;
import android.widget.HorizontalScrollView;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.PopupWindow;
import android.widget.RelativeLayout;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;

import com.fatangare.logcatviewer.service.LogcatViewerFloatingView;
import com.fatangare.logcatviewer.utils.LogcatViewer;
import com.talkcloud.media.TKPeerConnection;
import com.talkcloud.media.entity.RtcStats;
import com.talkcloud.media.entity.TKAudioFrame;
import com.talkcloud.media.entity.TKVideoFrame;

import com.talkcloud.media.entity.TK_AUDIO_STATE;
import com.talkcloud.media.entity.TK_VIDEO_STATE;
import com.talkcloud.room.RoomUser;

import com.talkcloud.room.TKMediaFrameObserver;
import com.talkcloud.room.TKNotificationCenter;
import com.talkcloud.room.TKNotificationName;
import com.talkcloud.room.TKRoomManager;
import com.talkcloud.room.TKRoomManagerObserver;
import com.talkcloud.room.TKVideoMirrorMode;
import com.talkcloud.room.TkAudioStatsReport;
import com.talkcloud.room.TkVideoStatsReport;
import com.talkcloud.room.VideoProfile;
import com.talkcloud.room.entity.TK_RECORD_STATE;


import org.json.JSONException;
import org.json.JSONObject;
import org.tkwebrtc.EglBase;
import org.tkwebrtc.MediaCodecVideoEncoder;
import org.tkwebrtc.RendererCommon;
import org.tkwebrtc.SurfaceViewRenderer;

import java.io.File;
import java.nio.ByteBuffer;
import java.nio.CharBuffer;
import java.nio.DoubleBuffer;
import java.nio.FloatBuffer;
import java.nio.IntBuffer;
import java.nio.LongBuffer;
import java.nio.ShortBuffer;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import cn.talkcloud.talksdkdemo.adapter.ChatMessageAdapter;
import cn.talkcloud.talksdkdemo.entity.ChatMessageModel;
import cn.talkcloud.talksdkdemo.utils.MyRel;
import cn.talkcloud.talksdkdemo.utils.ToastUtils;
import wei.mark.standout.StandOutWindow;


/**
 * Created by Administrator on 2018/4/10/010.
 */

public class VideoChatSampleActivity extends AppCompatActivity implements TKRoomManagerObserver,TKMediaFrameObserver ,TKNotificationCenter.NotificationCenterDelegate{

    private static final String TAG = VideoChatSampleActivity.class.getSimpleName();
    private static final int PERMISSION_REQ_ID_RECORD_AUDIO = 22;
    private static final int PERMISSION_REQ_ID_CAMERA = PERMISSION_REQ_ID_RECORD_AUDIO + 1;

    private HashMap<String,VideoItem> videoItems = new HashMap<>();
    HashMap<String, Boolean> playingMap = new HashMap<String, Boolean>();
    ArrayList<RoomUser> playingList = new ArrayList<RoomUser>();
    PowerManager pm;
    PowerManager.WakeLock mWakeLock;
    private PopupWindow pw =null;
    private ChatMessageAdapter mChatAdapter =null;
    private RecyclerView rv;
    //消息
    private List<ChatMessageModel> mMessagelist = null;
    ImageView iv_camer, iv_mute, iv_finsh;
    ImageView iv_switch,iv_av,iv_disting,iv_hands,iv_message,iv_share_screen,iv_mp3recorder_control,iv_enable_small;
    LinearLayout containerSelf;
    LinearLayout containerOther;
    HorizontalScrollView video_scroll;
    Button btn_switch_av;
    Spinner sp_videoprofiles;
    boolean videoIsPublish = true;
    boolean audioIsPublish = true;
    private boolean isclean = false;
    private AlertDialog.Builder builder = null;
    List<String> videoProfiles = new ArrayList<String>();
    private final static int[][] VIDEO_DEFINES = {{80, 60}, {176, 144}, {320, 180}, {320, 240}, {640, 480},{640, 360}, {1280, 720}, {1920, 1080}};

    int testCount = 0;
    boolean isTest = false;
    private static String host = "";
    private static String account = "";
    private static String type = "";
    private static String password = "";
    private static String nickname = "";
    private static boolean islogcat = false;
    private static boolean isSwithc = false;
    private static boolean ishands = false;
    private static boolean ischat = false;
    private static boolean isShareScreen = false;
    private static boolean isStartRecord = false;
    private static boolean enableSmall = false;
    private static boolean isJoinroom = false;
    private int checkedItemId = 0;
    MediaProjectionManager mediaProjectionManager;
    public static boolean isSmall = false;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        setContentView(R.layout.videochatsample);
        mediaProjectionManager = (MediaProjectionManager)
                getSystemService(Context.MEDIA_PROJECTION_SERVICE);
        account = getIntent().getStringExtra("account");
        type = getIntent().getStringExtra("type");
        password = getIntent().getStringExtra("password");
        islogcat = getIntent().getBooleanExtra("isLogcat", false);
        host = getIntent().getStringExtra("host");
        nickname = getIntent().getStringExtra("nickname");
        if (islogcat)
            LogcatViewer.showLogcatLoggerView(getApplicationContext());

        iv_camer = (ImageView) findViewById(R.id.iv_camer);
        iv_mute = (ImageView) findViewById(R.id.iv_mute);
        iv_finsh = (ImageView) findViewById(R.id.iv_finsh);

        iv_switch = (ImageView) findViewById(R.id.iv_switch);
        iv_av = (ImageView) findViewById(R.id.iv_av);
        iv_disting = (ImageView) findViewById(R.id.iv_disting);
        iv_hands = (ImageView) findViewById(R.id.iv_hands);
        iv_message = (ImageView) findViewById(R.id.iv_message);
        iv_share_screen = (ImageView) findViewById(R.id.iv_share_screen);
        iv_mp3recorder_control = (ImageView) findViewById(R.id.iv_mp3recorder_control);
        iv_enable_small = (ImageView) findViewById(R.id.iv_enable_small);


        containerSelf = (LinearLayout) findViewById(R.id.local_video_view_container);
        containerOther = (LinearLayout) findViewById(R.id.remote_video_view_container);
        video_scroll = (HorizontalScrollView) findViewById(R.id.video_scroll);
        video_scroll.setOnTouchListener(new View.OnTouchListener() {
            @Override
            public boolean onTouch(View v, MotionEvent event) {
                return false;
            }
        });
        iv_hands.setImageResource(R.mipmap.handsonclick);
        //初始化聊天界面
        InitPopView();
        //切换摄像头
        iv_switch.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                if (isSwithc)
                    TKRoomManager.getInstance().selectCameraPosition(false);
                else {
                    TKRoomManager.getInstance().selectCameraPosition(true);
                }
                isSwithc = !isSwithc;
            }
        });
        //音视频切换
        iv_av.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                TKRoomManager.getInstance().switchOnlyAudioRoom(!TKRoomManager.getInstance().isAudioOnlyRoom());
            }
        });

        //免提
        iv_hands.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (ishands) {
                    iv_hands.setImageResource(R.mipmap.handsonclick);
                    TKRoomManager.getInstance().useLoudSpeaker(true);
                } else {
                    iv_hands.setImageResource(R.mipmap.hands);
                    TKRoomManager.getInstance().useLoudSpeaker(false);
                }
                ishands = !ishands;
            }
        });

        //分辨率
        iv_disting.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                initList();
            }
        });
        //挂断/离开
        iv_finsh.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
//                if (isJoinroom) {
                    isExit = true;
                    TKRoomManager.getInstance().leaveRoom();
//                } else {
//                    finish();
//                }

            }
        });
        //消息界面
        iv_message.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (!ischat) {
                    iv_message.setImageResource(R.mipmap.message_press);
                    ShowPopMessage();
                } else {
                    iv_message.setImageResource(R.mipmap.message_default);
                    if (pw!=null)
                        pw.dismiss();
                }
                ischat = !ischat;
            }
        });
        iv_camer.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (!videoIsPublish) {
                    TKRoomManager.getInstance().publishVideo();
                } else {
                    TKRoomManager.getInstance().unPublishVideo();
                }
            }
        });

        iv_mute.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (!audioIsPublish) {
                    TKRoomManager.getInstance().publishAudio();
                } else {
                    TKRoomManager.getInstance().unPublishAudio();
                }
            }
        });
        iv_share_screen.setOnClickListener(new View.OnClickListener() {
            @RequiresApi(api = Build.VERSION_CODES.LOLLIPOP)
            @Override
            public void onClick(View v) {
                if(!isShareScreen){

                    startActivityForResult(
                            mediaProjectionManager.createScreenCaptureIntent(),
                            1002);
                }else{
                    iv_share_screen.setImageResource(R.drawable.share2);
                    if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.LOLLIPOP) {
                        TKRoomManager.getInstance().stopShareScreen();
                        isShareScreen = !isShareScreen;
                    }
                }

            }
        });
        iv_mp3recorder_control.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if(!isStartRecord){
                    iv_mp3recorder_control.setImageResource(R.drawable.stop01);
                    TKRoomManager.getInstance().startAudioRecording(new File(getExternalFilesDir(null).getAbsolutePath(), System.currentTimeMillis()+"_tkmp3").getPath());
                }else{
                    iv_mp3recorder_control.setImageResource(R.drawable.luzhi02);
                    TKRoomManager.getInstance().stopAudioRecording();
                }
                isStartRecord = !isStartRecord;
            }
        });
        iv_enable_small.setOnClickListener(new View.OnClickListener() {
            @RequiresApi(api = Build.VERSION_CODES.LOLLIPOP)
            @Override
            public void onClick(View v) {
                if(!enableSmall){
                    iv_enable_small.setImageResource(R.drawable.small01);
                }else{
                    iv_enable_small.setImageResource(R.drawable.small02);
                }
//                TKRoomManager.getInstance().pauseAudioRecording(isPauseRecord);
                enableSmall = !enableSmall;
//                TKRoomManager.getInstance().enableDualStream(enableSmall);
            }
        });


        if (checkSelfPermission(Manifest.permission.RECORD_AUDIO, PERMISSION_REQ_ID_RECORD_AUDIO) && checkSelfPermission(Manifest.permission.CAMERA, PERMISSION_REQ_ID_CAMERA)) {
            joinroom();
        }
//        else{
//            TKRoomManager.getInstance().registerRoomObserver(null);
//            for (String key:videoItems.keySet()) {
//                videoItems.get(key).sf_video.release();
//            }
//            videoItems.clear();
//            isExit = false;
//            this.finish();
//        }
    }

    //聊天界面
    private void ShowPopMessage() {
        pw.showAtLocation(findViewById(android.R.id.content), Gravity.BOTTOM, 0, 0);
    }
    private void InitPopView(){
        Display dp = getWindowManager().getDefaultDisplay();
        int height = dp.getHeight();
        View msView = LayoutInflater.from(this).inflate(R.layout.activity_chatmessage, null, false);
        final EditText editText = (EditText) msView.findViewById(R.id.et_message);
        ImageView ivSend = (ImageView) msView.findViewById(R.id.iv_send);
        rv = (RecyclerView) msView.findViewById(R.id.rlv_message);

        RecyclerView.LayoutManager layoutManager = new LinearLayoutManager(this);
        rv.setLayoutManager(layoutManager);
        rv.setNestedScrollingEnabled(true);
        mMessagelist = new ArrayList<>();
        mChatAdapter = new ChatMessageAdapter(mMessagelist);

        rv.setAdapter(mChatAdapter);
        //重写键盘按钮及监听键盘发送
        editText.setOnEditorActionListener(new TextView.OnEditorActionListener() {
            @Override
            public boolean onEditorAction(TextView v, int actionId, KeyEvent event) {
                if (actionId == EditorInfo.IME_ACTION_SEND) {
                    String content = editText.getText().toString().trim();
                    if (!TextUtils.isEmpty(content)) {
                        int state =TKRoomManager.getInstance().sendMessage(content, "__all", new HashMap<String, Object>());
                        if (state == 0) {
                            editText.setText("");
                        }
                    }
                }
                return false;
            }
        });
        //发送
        ivSend.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                String content = editText.getText().toString().trim();
                if (!TextUtils.isEmpty(content)) {
                    int state =TKRoomManager.getInstance().sendMessage(content, "__all", new HashMap<String, Object>());
                    if (state == 0) {
                        editText.setText("");
                    }
                }
            }
        });

        pw = new PopupWindow(ViewGroup.LayoutParams.MATCH_PARENT, height / 2);
        pw.setContentView(msView);
        //pop空白监听
        pw.setOnDismissListener(new PopupWindow.OnDismissListener() {
            @Override
            public void onDismiss() {
                iv_message.setImageResource(R.mipmap.message_default);
            }
        });
        pw.setBackgroundDrawable(new ColorDrawable(0x00000000));
        pw.setAnimationStyle(R.style.popwin_anim_style);
        //pop中edittext不弹出软键盘
        pw.setFocusable(true);
        pw.setOutsideTouchable(true);
        pw.setTouchable(true);

    }

    private void initList() {
        if (!isclean) {
            videoProfiles.clear();
            for (int i = 0; i < VIDEO_DEFINES.length; i++) {
                videoProfiles.add(VIDEO_DEFINES[i][0] + "X" + VIDEO_DEFINES[i][1]);
            }

            isclean = true;
        }

        String items[] = (String[]) videoProfiles.toArray(new String[0]);
        builder = new AlertDialog.Builder(this,videoProfiles.size());

        builder.setSingleChoiceItems(items, checkedItemId, new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                dialog.dismiss();
                checkedItemId = which;
                VideoProfile videoProfile = new VideoProfile();
                videoProfile.width = VIDEO_DEFINES[which][0];
                videoProfile.height = VIDEO_DEFINES[which][1];
                videoProfile.maxfps = 25;
                TKRoomManager.getInstance().setVideoProfile(videoProfile);
            }
        }).create().show();


    }

    private void joinroom() {

        TKRoomManager.getInstance().registerRoomObserver(this);
        TKRoomManager.getInstance().registerMediaFrameObserver(this);

        //加入课堂
        HashMap<String, Object> params = new HashMap<String, Object>();
        params.put("serial", account);//课堂号
        params.put("password", password); // 进入课堂人员身份（例如：老师。学生）密码
        params.put("userrole", Integer.parseInt(type));//身份
//        TKRoomManager.getInstance().setTestServer("global2.talk-cloud.net",8889);
//        TKRoomManager.getInstance().joinRoom("global.talk-cloud.neiwang", 80, "ad", params, null, true);
        if(TextUtils.isEmpty(host))
            host = "global.talk-cloud.net";
        host = host.trim();
//        TKRoomManager.getInstance().joinRoom("demo.talk-cloud.net", 80, "ad", params, null, true);
//        runOnUiThread(new Runnable() {
//            @Override
//            public void run() {
//                Log.e("xiao_01","beforeJoinRoom   ts = "+System.currentTimeMillis());
//            }
//        });
        TKNotificationCenter.getInstance().addObserver(this, TKNotificationName.onGetConfigReady);
        TKRoomManager.getInstance().joinRoom(host, 443, nickname, params, null);
//        TKRoomManager.getInstance().joinRoomEx("139432924106752","Android","talkcloud-Android",null);
        ToastUtils.showToast(this,"请稍后...");
    }

    int heigth;
    int width;
    @Override
    protected void onStart() {
        super.onStart();
        pm = (PowerManager) getSystemService(Context.POWER_SERVICE);
        mWakeLock = pm.newWakeLock(PowerManager.SCREEN_DIM_WAKE_LOCK, "My Tag");
        mWakeLock.acquire();
//        doPlayVideo();
    }

    @Override
    protected void onStop() {
        super.onStop();
        mWakeLock.release();
//        TKRoomManager.getInstance().pauseLocalCamera();
    }

    private boolean isExit = false;

    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        if (keyCode == KeyEvent.KEYCODE_BACK) {
            isExit = true;
            if(islogcat){
                StandOutWindow.closeAll(getApplicationContext(), LogcatViewerFloatingView.class);
            }
            TKRoomManager.getInstance().leaveRoom();

            return true;
        } else {
            return super.onKeyDown(keyCode, event);
        }
    }

    Handler handler = new Handler(){
        public void handleMessage(Message msg) {
            switch (msg.what) {
                case 1:
                    TKRoomManager.getInstance().publishAudio();
                    TKRoomManager.getInstance().publishVideo();
                    break;
            }
            super.handleMessage(msg);
        }

    };

    /***
     * 成功进入房间
     */
    @SuppressLint("NewApi")
    @Override
    public void onRoomJoined() {
        Log.d(TAG, "roomManagerRoomJoined");
        //加入课堂成功之后开始发布自己的音视频
        isJoinroom = true;
        Message message = new Message();
        message.what = 1;
        handler.sendMessage(message);

//        TKRoomManager.getInstance().changeUserPublish(TKRoomManager.getInstance().getMySelf().peerId,3);
        TKRoomManager tk=TKRoomManager.getInstance();
        TKRoomManager.getInstance().setLocalVideoMirrorMode(TKVideoMirrorMode.TKVideoMirrorModeAuto);
//        TKRoomManager.getInstance().startAudioRecording(new File(getExternalFilesDir(null).getAbsolutePath(), "tkmp3").getPath());
//        if (tk != null) {
////            int height = tk.get_room_video_height();
////            int width = tk.get_room_video_width();
//            Log.e("分辨率高", String.valueOf(height));
//            for (int i = 0; i < VIDEO_DEFINES.length; i++) {
//                if (height == VIDEO_DEFINES[i][1]&&width == VIDEO_DEFINES[i][0])
//                    checkedItemId = i;
//            }
//        }



        if (isTest) {
            TKRoomManager.getInstance().leaveRoom();
        }
        if(TKRoomManager.getInstance().getRoomProperties().has("vcodec")){
            int vcode = TKRoomManager.getInstance().getRoomProperties().optInt("vcodec");
            switch (vcode){
                case 0:
                    if(!MediaCodecVideoEncoder.isVp8HwSupported()) {
                        ToastUtils.showToast(this,"不支持VP8");
                    }
                    break;
                case 1:
                    if(!MediaCodecVideoEncoder.isVp9HwSupported()) {
                        ToastUtils.showToast(this,"不支持VP9");
                    }
                    break;
                case 2:
                    if(!MediaCodecVideoEncoder.isH264HwSupported()) {
                        ToastUtils.showToast(this,"不支持H264");
                    }
                    break;

            }
        }
//
//        for (int i = 0; i < MediaCodecList.getCodecCount(); ++i) {
//            MediaCodecInfo info = null;
//            try {
//                info = MediaCodecList.getCodecInfoAt(i);
//            } catch (IllegalArgumentException e) {
//                Logging.e(TAG, "Cannot retrieve encoder codec info", e);
//            }
//            if (info == null || !info.isEncoder()) {
//                continue;
//            }
//            String name = null;
//            for (String mimeType : info.getSupportedTypes()) {
////                if (mimeType.equals(mime)) {
//                    name = info.getName();
////                    break;
////                }
//            }
//            if (TextUtils.isEmpty(name)) {
//                continue; // No HW support in this codec; try the next one.
//            }else{
//                Toast.makeText(this, "name = "+name, Toast.LENGTH_LONG).show();
//            }
//        }
//        openSpeaker();

    }
    private void openSpeaker() {
        UiModeManager uiModeManager = (UiModeManager) getSystemService(Context.UI_MODE_SERVICE);
        if (uiModeManager.getCurrentModeType() != Configuration.UI_MODE_TYPE_TELEVISION) {
            try {
                AudioManager audioManager = (AudioManager) getSystemService(Context.AUDIO_SERVICE);
                audioManager.setMode(AudioManager.ROUTE_SPEAKER);
                int currVolume = audioManager.getStreamVolume(AudioManager.STREAM_MUSIC);
                TKRoomManager.getInstance().useLoudSpeaker(true);
                    audioManager.setMode(AudioManager.MODE_NORMAL);
                    audioManager.setSpeakerphoneOn(true);
                    audioManager.setStreamVolume(AudioManager.STREAM_MUSIC,
                            75,
                            AudioManager.STREAM_MUSIC);
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
    }

    /***
     * 离开课堂
     */
    @Override
    public void onRoomLeaved() {
        if (isTest) {
            if (testCount <= 100) {
                testCount++;
                Log.e("xiao_02", "testCount = " + testCount);
                joinroom();
                return;
            }
        }
        if (isExit) {
//            TKRoomManager.getInstance().stopAudioRecording();
            TKNotificationCenter.getInstance().removeObserver(this,TKNotificationName.onGetConfigReady);
            TKRoomManager.getInstance().registerRoomObserver(null);
            TKRoomManager.getInstance().registerMediaFrameObserver(null);
            for (String key:videoItems.keySet()) {
                videoItems.get(key).sf_video.release();
            }
            videoItems.clear();
            isExit = false;
            this.finish();
        }
    }

    @Override
    public void onConnectionLost() {
        containerOther.removeAllViews();
//        containerSelf.removeAllViews();
        videoItems.clear();
    }

//    @Override
//    public void onConnectionLost() {
//
//    }

    private void getPlayingList() {
        playingList.clear();

        for (String p : playingMap.keySet()) {
            if (playingMap.get(p)) {
                RoomUser u = TKRoomManager.getInstance().getUser(p);
//                if (playingList.size() >= 7) {
//                    return;
//                }
                playingList.add(u);
            }
        }
    }

    private int sitpos = -1;

    private void doPlayVideo() {
        for (String peerid:videoItems.keySet()) {
            if(TextUtils.isEmpty(videoItems.get(peerid).cameraId)){
                TKRoomManager.getInstance().playVideo(peerid,videoItems.get(peerid).sf_video, RendererCommon.ScalingType.SCALE_ASPECT_BALANCED);
            }else{
                TKRoomManager.getInstance().playVideo(peerid,videoItems.get(peerid).sf_video, RendererCommon.ScalingType.SCALE_ASPECT_BALANCED,videoItems.get(peerid).cameraId);
            }
        }
    }


    /***
     * @param user  用户对象
     * @param inList 在自己之前进入；false：在自己之后进入
     *  有用户进入房间
     */
    @Override
    public void onUserJoined(RoomUser user, boolean inList) {
        Log.d(TAG, "roomManagerPeerJoined " + user.nickName + (inList ? " inlist" : ""));
        /*if (inList && (user.role == 0 && RoomManager.getInstance().getMySelf().role == 0 ||
                (RoomManager.getInstance().getRoomType() == 0 && user.role == RoomManager.getInstance().getMySelf().role)))
            RoomManager.getInstance().evictUser(user.peerId);*/
    }

    /***
     *  有用户离开房间
     * user：用户对象
     */
    @Override
    public void onUserLeft(RoomUser user) {
        playingMap.remove(user.peerId);
        getPlayingList();
//        for (String peerid:videoItems.keySet()) {
//            if(peerid.equals(user.peerId)){
//                VideoItem vi = videoItems.get(peerid);
//                if(!TextUtils.isEmpty(vi.cameraId))
//                    TKRoomManager.getInstance().unPlayVideo(peerid,vi.cameraId);
//                else
//                    TKRoomManager.getInstance().unPlayVideo(peerid);
//                if(vi!=null){
//                    containerOther.removeView(vi.lin_parent);
//                    vi.sf_video.release();
//                    videoItems.remove(vi);
//                }
//            }
//        }
//        doUnPlayVideo(user, true);
//        doPlayVideo();
    }

    /***
     * @param user  用户对象
     * @param changedProperties 发生变化的属性
     *@param s
     *  有用户的属性发生了变化
     */
    @Override
    public void onUserPropertyChanged(RoomUser user, Map<String, Object> changedProperties, String s) {
//        Log.d(TAG, "roomManagerPeerChanged " + user.nickName + " " + changedProperties);
//        if (playingMap.containsKey(user.peerId) && user.publishState > 0) {
//            playingMap.put(user.peerId, user.publishState > 0);
//            if (user.publishState > 0) {
//                getPlayingList();
//                doPlayVideo();
//            } else {
//                getPlayingList();
//                doUnPlayVideo(user, false);
//            }
//        } else {
//            getPlayingList();
//            doUnPlayVideo(user, false);
//        }
    }


    @Override
    public void onUserVideoStatus(String peerid, int publishstate, String cameraId) {
        doPlayVideoNew(peerid, publishstate, cameraId,1);

    }

    private void doPlayVideoNew(String peerid, int publishstate, String cameraId,int mediaType) {
        Log.d(TAG, "onUserVideoStatus " + peerid + " " + publishstate+"cameraId = "+cameraId);
        if(peerid.equals(TKRoomManager.getInstance().getMySelf().peerId)){
            if(publishstate == 1){
                videoIsPublish = true;
                iv_camer.setImageResource(R.drawable.cameraoff);
                RoomUser user = TKRoomManager.getInstance().getUser(peerid);
                if(user == null) {
                    return;
                }
                final VideoItem vi = new VideoItem();
                vi.lin_parent = (MyRel) LayoutInflater.from(this).inflate(R.layout.video, null);
                vi.sf_video = (SurfaceViewRenderer) vi.lin_parent.findViewById(R.id.sf_video);

               /* vi.iv_display = (ImageView) vi.lin_parent.findViewById(R.id.iv_display);*/

                vi.btn_video = (AutoFitTextView) vi.lin_parent.findViewById(R.id.btn_video);
                vi.btn_audio = (AutoFitTextView) vi.lin_parent.findViewById(R.id.btn_audio);
                vi.btn_video.setVisibility(View.GONE);
                vi.btn_audio.setVisibility(View.GONE);

                vi.sf_video.init(EglBase.create().getEglBaseContext(), null);
                vi.peerid = user.peerId;
                vi.cameraId = cameraId;


                containerSelf.removeAllViews();

                containerSelf.addView(vi.lin_parent);
                vi.sf_video.setZOrderOnTop(false);
              /*  vi.iv_display.setVisibility(View.VISIBLE);*/
//        if (user.publishState > 1) {
                if(TextUtils.isEmpty(cameraId)){
                    TKRoomManager.getInstance().playVideo(user.peerId, vi.sf_video, RendererCommon.ScalingType.SCALE_ASPECT_BALANCED);
                }else{
                    TKRoomManager.getInstance().playVideo(user.peerId, vi.sf_video, RendererCommon.ScalingType.SCALE_ASPECT_BALANCED,cameraId);
                }

                LinearLayout.LayoutParams params = (LinearLayout.LayoutParams) vi.lin_parent.getLayoutParams();
                params.gravity = Gravity.TOP;
                vi.lin_parent.setLayoutParams(params);
                RelativeLayout.LayoutParams vparams = (RelativeLayout.LayoutParams) vi.sf_video.getLayoutParams();
                vparams.addRule(RelativeLayout.ALIGN_PARENT_TOP);
                vi.sf_video.setLayoutParams(vparams);

                videoItems.put(vi.peerid+vi.cameraId,vi);
//        }
//        if (user.publishState >= 1&&user.publishState!=2)
//                TKRoomManager.getInstance().playAudio(user.peerId);
            }else{
                videoIsPublish = false;
                iv_camer.setImageResource(R.drawable.cameraon);
                if(!TextUtils.isEmpty(cameraId)) {
                    TKRoomManager.getInstance().unPlayVideo(peerid,cameraId);
                }
                else {
                    TKRoomManager.getInstance().unPlayVideo(peerid);
                }
                VideoItem vi = videoItems.get(peerid+cameraId);
                if(vi!=null){
                    containerSelf.removeAllViews();
                    vi.sf_video.release();
                    videoItems.remove(vi);
                }
            }
        }else{
            if(publishstate == 1){
                final VideoItem vi = videoItems.containsKey(peerid+cameraId+mediaType)?videoItems.get(peerid+cameraId+mediaType):new VideoItem();
                vi.lin_parent = (MyRel) LayoutInflater.from(this).inflate(R.layout.video, null);
                vi.sf_video = (SurfaceViewRenderer) vi.lin_parent.findViewById(R.id.sf_video);
               /* vi.iv_display = (ImageView) vi.lin_parent.findViewById(R.id.iv_display);*/

                vi.btn_video = (AutoFitTextView) vi.lin_parent.findViewById(R.id.btn_video);
                vi.btn_audio = (AutoFitTextView) vi.lin_parent.findViewById(R.id.btn_audio);
                vi.btn_video.setVisibility(View.GONE);
                vi.btn_audio.setVisibility(View.GONE);

                vi.sf_video.init(EglBase.create().getEglBaseContext(), null);
                vi.peerid = peerid;
                vi.cameraId = cameraId;
//                vi.sf_video.setZOrderOnTop(true);
                containerOther.addView(vi.lin_parent);
                containerOther.bringToFront();
                vi.lin_parent.bringToFront();
                vi.sf_video.bringToFront();
                vi.sf_video.setZOrderMediaOverlay(true);
                vi.sf_video.setOnTouchListener(new View.OnTouchListener() {
                    @Override
                    public boolean onTouch(View v, MotionEvent event) {
                        return false;
                    }
                });
                containerOther.setOnTouchListener(new View.OnTouchListener() {
                    @Override
                    public boolean onTouch(View v, MotionEvent event) {
                        return false;
                    }
                });
                if(mediaType == 3){
                    TKRoomManager.getInstance().playScreen(peerid,vi.sf_video);
                }else{
                    if(TextUtils.isEmpty(cameraId)){
                        TKRoomManager.getInstance().playVideo(peerid, vi.sf_video, RendererCommon.ScalingType.SCALE_ASPECT_BALANCED);
                    }else{
                        TKRoomManager.getInstance().playVideo(peerid, vi.sf_video, RendererCommon.ScalingType.SCALE_ASPECT_BALANCED,cameraId);
                    }
                }
//                TKRoomManager.getInstance().resumeLocalCamera();
                DisplayMetrics dm = getResources().getDisplayMetrics();
                heigth = dm.heightPixels;
                width = dm.widthPixels;
                LinearLayout.LayoutParams params = (LinearLayout.LayoutParams) vi.lin_parent.getLayoutParams();
                params.width = width / 4;
                params.height = width / 4;
                params.gravity = Gravity.BOTTOM;
                vi.lin_parent.setLayoutParams(params);
                RelativeLayout.LayoutParams vparams = (RelativeLayout.LayoutParams) vi.sf_video.getLayoutParams();
                vparams.addRule(RelativeLayout.CENTER_VERTICAL);
                vi.sf_video.setLayoutParams(vparams);
                vi.sf_video.setOnClickListener(new View.OnClickListener() {
                    @Override
                    public void onClick(View v) {
                        vi.isSmall = !vi.isSmall;
//                        TKRoomManager.getInstance().setRemoteVideoStreamType(vi.isSmall? TK_VIDEO_STREAM_TYPE.TK_VIDEO_STREAM_SMALL:TK_VIDEO_STREAM_TYPE.TK_VIDEO_STREAM_BIG,vi.peerid,vi.cameraId);
                    }
                });
                videoItems.put(vi.peerid+vi.cameraId+mediaType,vi);
            }else{
                VideoItem vi = videoItems.get(peerid+cameraId+mediaType);
                if(mediaType == 3){
                    TKRoomManager.getInstance().unPlayScreen(peerid);
                }else{

                    if(!TextUtils.isEmpty(cameraId))
                        TKRoomManager.getInstance().unPlayVideo(peerid,cameraId);
                    else
                        TKRoomManager.getInstance().unPlayVideo(peerid);
                }
                if(vi!=null){
                    vi.sf_video.release();
                    containerOther.removeView(vi.lin_parent);
                    videoItems.remove(vi);
                }
            }
        }
    }


    @Override
    public void onUserVideoStatus(String peerid, int state) {
        Log.d(TAG, "onUserVideoStatus " + peerid + " " + state);
        doPlayVideoNew(peerid,state,null,1);
    }

    @Override
    public void onUserAudioStatus(String peerid, int state) {
        Log.d(TAG, "onUserAudioStatus " + peerid + " " + state);
        if(state == 1){
            TKRoomManager.getInstance().playAudio(peerid);
            if(peerid.equals(TKRoomManager.getInstance().getMySelf().peerId)){
                audioIsPublish = true;
                iv_mute.setImageResource(R.drawable.mute);
            }
        }else{
            TKRoomManager.getInstance().unPlayAudio(peerid);
            if(peerid.equals(TKRoomManager.getInstance().getMySelf().peerId)){
                audioIsPublish = false;
                iv_mute.setImageResource(R.drawable.unmute);
            }
        }
    }

    /***
     * 自己被踢出房间
     * @param reason 被踢的原因 0 同身份踢掉，1 被老师请出房间
     */
    @Override
    public void onKickedout(JSONObject jsobject) {
        isExit = true;
        finish();
    }

    /***
     *    收到聊天消息
     */
    @Override
    public void onMessageReceived(RoomUser roomUser, JSONObject message, long ts) {
        String content =null;
        try {
            content = message.getString("msg");
            if (roomUser != null && !TextUtils.isEmpty(content)) {
                if (roomUser.peerId.equals(TKRoomManager.getInstance().getMySelf().peerId))
                    mMessagelist.add(new ChatMessageModel(roomUser.peerId,roomUser.nickName,content,1));
                else
                    mMessagelist.add(new ChatMessageModel(roomUser.peerId, roomUser.nickName, content, 0));

                mChatAdapter.notifyDataSetChanged();
                rv.scrollToPosition(mChatAdapter.getItemCount()-1);
            }

        } catch (JSONException e) {
            e.printStackTrace();
        }


    }

    public void onShareMediaState(String peerId, int state, Map<String, Object> attrs) {
        if (state > 0) {
            playingMap.put(peerId, true);
        } else {
            playingMap.remove(peerId);
        }
    }








    public void onShareScreenState(String peerId, int state) {
        if (state > 0) {
            playingMap.put(peerId+"screen", true);
        } else {
            playingMap.remove(peerId+"screen");
        }
        if(!peerId.equals(TKRoomManager.getInstance().getMySelf().peerId)){
            doPlayVideoNew(peerId,state,null,3);
        }
    }

    /***
     * 错误回调
     * @param errorCode
     *  错误码：
     *1501 摄像头丢失
     *1502 socket 5次链接失败，应退出教室
     *1503 udp链接异常(链接成功过)
     *1504 udp链接异常（没有链接成功过，防火墙拦截）
     *1505 房间视频路数已达上限
     *
     * 进入房间的错误：
     *3001 服务器过期
     *3002 公司被冻结
     *3003 教室被删除或过期
     *4007 教室不存在
     *4008 教室密码错误
     *4110 该教室需要密码，请输入密码
     * @param errMsg 错误描述
     */
    public void onError(final int errorCode, final String errMsg) {
        Log.d("classroom", "errorcode = " + errorCode + "---" + errMsg);
        if (errorCode != 0)
            Toast.makeText(VideoChatSampleActivity.this,"进入教室失败，错误码："+errorCode,Toast.LENGTH_LONG).show();
        if(errorCode == 10002||errorCode == 3001||errorCode == 3002||errorCode == 3003||errorCode == 4007||errorCode == 4008||errorCode == 4110||errorCode == 4012){
//            isExit = true;
//            TKRoomManager.getInstance().leaveRoom();
//            this.finish();
        }
    }

    /***
     *
     * @param warning
     *1751摄像头打开
     *1752摄像头关闭
     */
    public void onWarning(int warning) {

    }


    public void onShareFileState(String peerId, int state) {
        if (state > 0) {
            playingMap.put(peerId, true);
        } else {
            playingMap.remove(peerId);
        }
    }

    @Override
    public void onAudioVolume(String s, int i) {
        if(s.equals(TKRoomManager.getInstance().getMySelf().peerId)){
            Log.e("xiao","peerid = "+s+"----volume = "+i);
        }
    }



    @Override
    public void onVideoStatsReport(String peerId, TkVideoStatsReport statsReport) {
//        Log.e(String.format("onVideoStatsReport peerid = %s", peerId),statsReport.toString());
        if(peerId.equals(TKRoomManager.getInstance().getMySelf().peerId+":screen")){
            Log.e(String.format("onVideoStatsReport peerid = %s", peerId),statsReport.toString());
        }
        statsReport = null;
    }

    @Override
    public void onAudioStatsReport(String peerId, TkAudioStatsReport statsReport) {
        Log.e(String.format("onAudioStatsReport peerid = %s", peerId),statsReport.toString());
        statsReport = null;
    }

    @Override
    public void onGetRoomUsersBack(int i, ArrayList<RoomUser> arrayList) {

    }

    @Override
    public void onGetRoomUserNumBack(int i, int i1) {

    }

    @Override
    public void onAudioRoomSwitch(String peerid, boolean isSwitch) {
        RoomUser user = TKRoomManager.getInstance().getUser(peerid);
        if (user != null) {
            //ture 开启纯音教室 false关闭
            if (isSwitch)
                ToastUtils.showToast(this,user.nickName+"切换为纯音教室");
            else
                ToastUtils.showToast(this,user.nickName+"切换为音视频教室");


        }
    }


    @Override
    public void onFirstVideoFrame(String peerID, int mediaType, int width, int height) {
        if(!TKRoomManager.getInstance().getMySelf().peerId.equals(peerID)){
            Log.e("xiao_____2","onFirstVideoFrame peerid = "+peerID+"  time="+System.currentTimeMillis());
        }
        Log.e(TAG, "onFirstVideoFrame: "+"peerid="+peerID+"width="+width+"height="+height );
    }

    @Override
    public void onFirstVideoFrame(String peerID, int width, int height, int mediaType, String deviceid) {
        if(!TKRoomManager.getInstance().getMySelf().peerId.equals(peerID)){
            Log.e("xiao_____2","onFirstVideoFrame peerid = "+peerID+"  time="+System.currentTimeMillis());
        }
        Log.e(TAG, "onFirstVideoFrame: "+"peerid="+peerID+"width="+width+"height="+height );
    }

    @Override
    public void onFirstAudioFrame(String peerID, int mediaType) {
        if(!TKRoomManager.getInstance().getMySelf().peerId.equals(peerID)){
            Log.e("xiao_____2","onFirstAudioFrame peerid = "+peerID+"  time="+System.currentTimeMillis());
        }
        Log.e(TAG, "onFirstAudioFrame: "+"peerid="+peerID );
    }

    @Override
    public void onNetworkQuality(int i, long l) {

    }

    @Override
    public void onInfo(int i, String s) {

    }

    @Override
    public void onVideoDeviceStateChanged(String s, int i) {

    }

    @Override
    public void onRtcStatsReport(RtcStats rtcStats) {
        Log.e("onRtcStatsReport",rtcStats.toString());
    }

    @Override
    public void onVideoStateChange(String s, String s1, TK_VIDEO_STATE tk_video_state) {

    }

    @Override
    public void onAudioStateChange(String s, TK_AUDIO_STATE tk_audio_state) {
        Log.d("onAudioStateChange",tk_audio_state.toString());
    }

    @Override
    public void onRoomServerRecordStateChange(TK_RECORD_STATE var1, String var2, HashMap<String, Object> var3){
        Log.d("onAudioStateChange",var2);
    }
//    @Override
//    public void onVideoDeviceStateChanged(String s, int i) {
//
//    }


    /***
     *   收到自定义信令消息
     */
    @Override
    public void onRemotePubMsg(String s, String s1, long l, Object o, boolean b1, String s2, String s3, String s4,JSONObject data) {
        if (s.equals("OnlyAudioRoom")) {
            iv_av.setImageResource(R.mipmap.audio);
        }


    }
    @Override
    public void onRemotePubMsg(String s, String s1, long l, Object o, boolean b1, String s2, String s3, String s4) {



    }

    /***
     *   删除自定义信令消息
     */
    @Override
    public void onRemoteDelMsg(String s, String s1, long l, Object o, boolean b1, String s2, String s3, String s4,JSONObject data) {
        if (s.equals("OnlyAudioRoom")) {
            iv_av.setImageResource(R.mipmap.av);
        }

    }
    @Override
    public void onRemoteDelMsg(String s, String s1, long l, Object o, boolean b1, String s2, String s3, String s4) {


    }

    /***
     *   媒体视频播放暂停
     */
    @Override
    public void onUpdateAttributeStream(String s, long l, boolean b, HashMap<String, Object> hashMap) {

    }


    public boolean checkSelfPermission(String permission, int requestCode) {
        if (ContextCompat.checkSelfPermission(this,
                permission)
                != PackageManager.PERMISSION_GRANTED) {

            ActivityCompat.requestPermissions(this,
                    new String[]{permission},
                    requestCode);
            return false;
        }
        return true;
    }

    @Override
    public void onRequestPermissionsResult(int requestCode,
                                           @NonNull String permissions[], @NonNull int[] grantResults) {
        switch (requestCode) {
            case PERMISSION_REQ_ID_RECORD_AUDIO: {
                if (grantResults.length > 0
                        && grantResults[0] == PackageManager.PERMISSION_GRANTED) {
                    checkSelfPermission(Manifest.permission.CAMERA, PERMISSION_REQ_ID_CAMERA);
                } else {
                    /*Tools.ShowAlertDialog(this, getString(R.string.mic_hint));*/
                    showLongToast("No permission for " + Manifest.permission.RECORD_AUDIO);
                }
                break;
            }
            case PERMISSION_REQ_ID_CAMERA: {
                if (grantResults.length > 0
                        && grantResults[0] == PackageManager.PERMISSION_GRANTED) {
                    joinroom();
                } else {
                    showLongToast("No permission for " + Manifest.permission.CAMERA);
                    /*Tools.ShowAlertDialog(this, getString(R.string.camera_hint));*/
                }
                break;
            }
        }
    }

    public final void showLongToast(final String msg) {
        this.runOnUiThread(new Runnable() {
            @Override
            public void run() {
                Toast.makeText(getApplicationContext(), msg, Toast.LENGTH_LONG).show();
            }
        });
    }

    @Override
    public boolean onCaptureAudioFrame(TKAudioFrame tkAudioFrame, String s, int i) {
        return false;
    }

    @Override
    public boolean onRenderAudioFrame(TKAudioFrame tkAudioFrame, String s, int i) {
        return false;
    }

    @Override
    public boolean onCaptureVideoFrame(TKVideoFrame tkVideoFrame, String s) {
        Log.e("onCaptureVideoFrame","peerid = "+s+"width = "+tkVideoFrame.width+"--height = "+tkVideoFrame.height+"--角度="+tkVideoFrame.rotation);
        return false;
    }

    @Override
    public boolean onRenderVideoFrame(TKVideoFrame tkVideoFrame, String s, int i) {
        if(!s.equals(TKRoomManager.getInstance().getMySelf().peerId)){
//            byte[] b = new byte[tkVideoFrame.width*tkVideoFrame.height/4];
//            tkVideoFrame.uBuffer.put(b,0,tkVideoFrame.width*tkVideoFrame.height/4);

            Log.e("onRenderVideoFrame","peerid = "+s+"width = "+tkVideoFrame.width+"--height = "+tkVideoFrame.height+"--角度="+tkVideoFrame.rotation);
        }
        return false;
    }

    @Override
    public boolean onRenderVideoFrame(TKVideoFrame tkVideoFrame, String s, int i, String s1) {
        if(!s.equals(TKRoomManager.getInstance().getMySelf().peerId)){
            Log.e("onRenderVideoFrame","peerid = "+s+"width = "+tkVideoFrame.width+"--height = "+tkVideoFrame.height);
        }
        return false;
    }

    @Override
    protected void onSaveInstanceState(Bundle outState) {
        super.onSaveInstanceState(outState);
    }

    @Override
    public void onSaveInstanceState(Bundle outState, PersistableBundle outPersistentState) {
        super.onSaveInstanceState(outState, outPersistentState);
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        if(requestCode == 1002&&resultCode == Activity.RESULT_OK){
            if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.LOLLIPOP) {
                iv_share_screen.setImageResource(R.drawable.share1);
                TKRoomManager.getInstance().startShareScreen(data);
                isShareScreen = !isShareScreen;
            }
        }
    }

    @Override
    public void didReceivedNotification(int i, Object... objects) {
        if(i == TKNotificationName.onGetConfigReady){
            TKNotificationCenter.getInstance().postNotificationName(TKNotificationName.onGetReadyEnterRoom);
        }
    }
}
